<template>
    <div class="row">
        <div class="col-md-12">
            <div class="panel panel-default">
                <div class="panel-body">
                    <div class="form-inline">
                        <div v-show="false" class="form-group">
                            <select class="form-control" v-model="report_type">
                                <option value="active">Active Invoices</option>
                                <option value="sales_return">Sales Return</option>
                            </select>
                        </div>

                        <div class="form-group">
                            <select class="form-control" v-model="date_type">
                                <option value="ad">AD</option>
                                <option value="bs">BS</option>
                            </select>
                        </div>

                        <div class="form-group">
                            <select name="month" id="month" class="form-control" v-model="monthSelected">
                                <option value="">--SELECT MONTH--</option>
                                <option v-for="(month, index) in monthOption[date_type]" :value="index + 1" v-text="month"></option>
                            </select>
                        </div>

                        <div class="form-group">
                            <select name="year" id="year" class="form-control" v-model="yearSelected">
                                <option value="">--SELECT YEAR--</option>
                                <option v-for="year in yearOption[date_type]" :value="year" v-text="year"></option>
                            </select>
                        </div>

                        <div class="form-group">
                            <input type="button" class="btn btn-default btn-generate" :value="generateText" @click="generate">
                        </div>
                    </div>
                </div>
            </div>
        </div>

        <div v-show="generatingStatus !== ''" class="col-md-12">
            <div class="panel panel-default invoice">
                <div class="panel-heading">
                    <h4 class="panel-title"></h4>
                    <div class="export-buttons">
                        <a href="#" @click="exportToExcel" class="tip" data-original-title="Export to Excel">
                            <i class="fa fa-file-excel-o s24"></i>
                        </a>
                        <a href="#" @click="exportToPdf" class="tip" data-original-title="Export to Pdf">
                            <i class="fa fa-file-pdf-o s24"></i>
                        </a>
                    </div>
                </div>
                <div class="panel-body">
                    <div v-html="generatedResult"></div>
                </div>
            </div>
        </div>
    </div>
</template>

<script type="text/ecmascript-6">
    import axios           from "axios";
    import {toQueryString} from "./../../helpers/helper";

    export default {
        name: "SalesBook",

        props: {
            generateApi: {required: true, type: String},
            exportApi: {required: true, type: String},
            type: {required: true, type: String},
        },

        data() {
            return {
                report_type: "active",
                date_type: "ad",

                monthOption: {
                    ad: ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"],
                    bs: ["बैशाख", "जेठ", "असार", "सावन", "भदौ", "असोज", "कार्तिक", "मंसिर", "पौष", "माघ", "फागुन", "चैत"],
                },

                yearOption: {
                    ad: [2018, 2019],
                    bs: [2075, 2076],
                },

                yearSelected: "",
                monthSelected: "",
                generatingStatus: "",
                generatedResult: "",
            };
        },

        watch: {
            type: {
                handler: function(type) {
                    this.report_type = type === 'sales-book' ? 'active' : 'sales_return'
                },
                immediate: true,
            },
        },

        computed: {
            generateText: function() {
                return this.generatingStatus === "generating" ? "Generating..." : "Generate";
            },

            queryData: function() {
                return {
                    report_type: this.report_type,
                    date_type: this.date_type,
                    year: this.yearSelected,
                    month: this.monthSelected,
                };
            },
        },

        mounted() {
        },

        methods: {
            generate() {
                if (!this.date_type || !this.yearSelected || !this.monthSelected || this.generatingStatus === "generating") {
                    this.generatingStatus = "";
                    return;
                }

                this.generatingStatus = "generating";

                const _self = this;
                axios.post(this.generateApi, this.queryData).then(response => {
                    _self.generatingStatus = "generated";
                    this.generatedResult = response.data;
                }).catch(error => {
                    _self.generatingStatus = "";
                });
            },

            exportToPdf() {
                let url = this.exportApi.replace(/__TYPE__/g, "pdf");

                this.exportReport(url);
            },

            exportToExcel() {
                let url = this.exportApi.replace(/__TYPE__/g, "excel");

                this.exportReport(url);
            },

            exportReport(url) {
                url += toQueryString(this.queryData);

                window.location.href = url;
            },
        },
    };
</script>

<style scoped>
    .btn-generate {
        margin-bottom: 1px;
    }

    .export-buttons {
        width: auto;
        float: right;
        position: absolute;
        right: 10px;
        top: 10px;
    }
</style>
